<template>
  <a-modal
    :title="modalTitle"
    :width="640"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @cancel="handleCancel"
  >
    <a-form :form="form">
      <a-form-item
        label="上传文件"
        :labelCol="BaseTool.Constant.labelCol"
        :wrapperCol="BaseTool.Constant.wrapperCol"
      >
        <a-upload :fileList="fileList" @change="handleChange" :remove="handleRemove" :beforeUpload="beforeUpload">
          <a-button> <a-icon type="upload" />选择上传文件</a-button>
        </a-upload>
      </a-form-item>
    </a-form>
    <template slot="footer">
      <a-button :loading="confirmLoading" type="primary" @click="save()">确定</a-button>
    </template>
  </a-modal>
</template>

<script>
import { importPurchaseOrderListForEnquiry } from '@/api/purchase/purchase-order-list'

export default {
  name: 'BasePurchaseOrderListImportForm',
  data () {
    return {
      confirmLoading: false,
      modalTitle: null,
      form: this.$form.createForm(this),
      order: {},
      visible: false,
      fileList: []
    }
  },
  methods: {
    base (order) {
      this.visible = true
      this.order = order
      this.fileList = []
      this.modalTitle = '询价导入'
    },
    handleRemove (file) {
      const index = this.fileList.indexOf(file)
      const newFileList = this.fileList.slice()
      newFileList.splice(index, 1)
      this.fileList = newFileList
    },
    beforeUpload (file) {
      const reg = /\.(xls|xlsx)(\?.*)?$/
      return new Promise((resolve, reject) => {
        if (reg.test(file.name)) {
          this.fileList = [file]
          return false
        } else {
          this.$message.error(`请上传正确的excel文件`)
          reject(new Error('请上传正确的excel文件'))
          return false
        }
      })
    },
    handleChange (info) {
      if (info.file.status !== 'uploading') {
        console.log(info.file, info.fileList)
      }
      if (info.file.status === 'done') {
        this.$message.success(`${info.file.name} file uploaded successfully`)
      } else if (info.file.status === 'error') {
        this.$message.error(`${info.file.name} file upload failed.`)
      }
    },
    save () {
      this.confirmLoading = true
      if (this.fileList.length !== 1) {
        this.$message.error('请上传文件')
        return
      }
      const moneyType = this.$store.getters.moneyType
      if (!moneyType) {
        this.$message.error('请先选择币种')
        return
      }
      const formData = new FormData()
      formData.append('file', this.fileList[0])
      formData.append('moneyType', moneyType)
      formData.append('exchangeRate', this.$store.getters.exchangeRate)
      formData.append('purchaseOrderId', this.order.id)
      importPurchaseOrderListForEnquiry(formData)
        .then((res) => {
          this.handleCancel({})
        }).catch(() => {
          this.confirmLoading = false
        })
    },
    handleCancel (values) {
      this.visible = false
      this.confirmLoading = false
      this.form.resetFields()
      this.$emit('ok', values)
    }

  }
}
</script>
